## action

为一个{普通函数|Generator函数}添加了简单的装饰特性,使其也在执行前后注入其他逻辑.

例.
```
Action.$inject = ['db','output'];
Action.$before = [];
Action.$after  = [];

//也可以是个GeneratorFunction
function Action() {
    this.output.flag = 1;
    this.output.count = 100;
    this.db.set('操作DB写数据');
    this.db.desc = 'DB本不存在这个属性写了也没有';
    this.desc = '非依赖注入对象是可以看到滴'
}


//所有Action都应该在一个容器内运行, 这样使用$inject修饰的对象才能在运行时取到.
let container = {
    db: {
        _data: '',
        set: function(value) {
            this._data = value;
        },
        get: function() {
            return this._data;
        }
    }
    output: {

    }
}

let manager = new action.Manager();

manager.add('test', Action);
manager.run('test', [], container)
```