'use strict';
var assert = require("assert");
var fs = require("fs");
var action = require('../../lib/action');

let container = {
    db: {
        _dt: '',
        get: function () {
            return this._dt;
        },
        set: function (value) {
            this._dt = value;
        }
    },
    input: {
        name: 'test',
        desc: 'test_dest'
    },
    output: {
        count: 0
    }
};
//BEGIN: define
test.$before = [
    function () {
        this.count = 0;
        this[++this.count] = Date.now();
    },

    function () {
        this[++this.count] = Date.now();
    },

    function () {
        this[++this.count] = Date.now();
        return new Promise((resove)=> {
            setTimeout(()=> resove(), 100);
        });
    }
];
function test() {
    this[++this.count] = Date.now();
}
test.$after = [
    function () {
        this[++this.count] = Date.now();
        return new Promise((resove)=> {
            setTimeout(()=> resove(), 100);
        });
    },
    function () {
        this[++this.count] = Date.now();
        return new Promise((resove)=> {
            setTimeout(()=> resove(), 100);
        });
    },
    function () {
        this[++this.count] = Date.now();
        return new Promise((resove)=> {
            setTimeout(()=> resove(), 100);
        });
    }
];
//END: define


describe('Action', function () {
    it('run', (done) => {
        let manager = new action.Manager();

        manager.add('test', test);

        manager.run('test', []).then((data)=> {
            assert.equal(data.count, 7, '应该等于7次');
            done();
        }).catch(done);
    });

    it('run', (done) => {
        let manager = new action.Manager();

        manager.load();

        manager.run('inject', [], container).then((data)=>{
            done();
        }).catch(error=>done(error));
    });


    it('run generatorfunction', (done) => {
        let manager = new action.Manager();
        let container = {
            output: 'test output'
        };

        manager.load();

        manager.run('gen', ['test arg'], container).then((data)=>{
            done();
        }).catch(error=>done(error));
    });
});
